%define _docdir		%{_hhl_cross_target_dir}%{_hhl_target_doc_dir}

Summary		: A CRT screen handling and optimization package.
Name		: ncurses%{_hhl_pkg_suffix}
Version		: 5.4
Release		: 2.0.0.%{_hhl_build_id}
Source		: ncurses_%{version}.orig.tar.gz
Source1		: hhl-libopt-build-ncurses
Patch 		: ncurses_5.4-4.diff.gz
Patch1 		: cross-5.4.diff 
Patch2 		: cross-static.diff
License		: Other
Group		: libs
Buildroot	: %{_tmppath}/%{name}-%{_hhl_target_arch}-root
Prefix		:  %{_hhl_cross_target_dir}
Obsoletes 	: hhl-target-ncurses

%description

 The curses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.  The ncurses
 (new curses) library is a freely distributable replacement for the
 discontinued 4.4BSD classic curses library.

 Ncurses also contains libtermcap functionality and should be linked
 into programs instead of libtermcap.

%package -n libncurses%{_hhl_pkg_suffix}
Summary		: Shared libraries for terminal handling
Group		: base
Requires	: ncurses-base = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-libncurses

%description -n libncurses%{_hhl_pkg_suffix}

 This package contains the shared libraries necessary to run programs
 compiled with ncurses.

%package -n libncurses-dev%{_hhl_pkg_suffix}
Summary		: Developer's libraries for ncurses
Group		: devel
Requires	: libncurses%{_hhl_pkg_suffix} = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-libncurses-dev

%description -n libncurses-dev%{_hhl_pkg_suffix}

 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.

%package -n libncurses-dbg%{_hhl_pkg_suffix}
Summary		: Debugging/profiling libraries for ncurses
Group		: devel
Requires	: libncurses-dev%{_hhl_pkg_suffix} = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-libncurses-dbg

%description -n libncurses-dbg%{_hhl_pkg_suffix}

 This package contains the static debugging and profiling libraries and
 symbolic links that developers using ncurses will need.

%package -n libncurses-pic%{_hhl_pkg_suffix}
Summary		: Ncurses PIC archive library
Group		: devel
Requires	: libncurses%{_hhl_pkg_suffix} = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-libncurses-pic

%description -n libncurses-pic%{_hhl_pkg_suffix}

 This package contains an archive file (ar file) componed of individual 
 shared objects.  This is used for creating a library which is a smaller 
 subset of the standard ncurses shared library.

%package -n libncurses-libopt%{_hhl_pkg_suffix}
Summary		: Ncurses Library Optimizer information
Group		: devel
Requires	: libncurses%{_hhl_pkg_suffix} = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-libncurses-libopt%{_hhl_pkg_suffix}

%description -n libncurses-libopt%{_hhl_pkg_suffix}

 Contains information for the Library Optimizer Tool.
 This is used for creating a library which is a smaller 
 subset of the standard ncurses shared library.

%if "%{_hhl_pkg_suffix}" == ""
%package -n ncurses-bin
Summary		: Terminal-related programs and man pages
Group		: devel
Requires	: libncurses = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-ncurses-bin

%description -n ncurses-bin

 This package contains the programs used for manipulating the terminfo
 database and individual terminfo entries, as well as some programs for
 resetting terminals and such.


%package -n ncurses-base
Summary		: Descriptions of common terminal types
Group		: base
Obsoletes 	: hhl-%{_hhl_target_arch}-ncurses-base

%description -n ncurses-base

 This package contains what should be a reasonable subset of terminal
 definitions, including: ansi, dumb, linux, rxvt, screen, sun, vt100,
 vt102, vt220, vt52, and xterm.

%package -n ncurses-term
Summary		: Additional terminal type definitions
Group		: base
Requires	: ncurses-base = %{version}
Obsoletes 	: hhl-%{_hhl_target_arch}-ncurses-term

%description -n ncurses-term

 This package contains all of the terminal definitions not found in
 the ncurses-base package.  There are far too many to list here. 

%endif

%prep
%target_check
%setup -q -n ncurses-%{version}
%patch -p1
%patch1 -p1
%patch2 -p1

%build
# We build a full version for the host... easy way to get a runable tic
mkdir HOSTOBJDIR
cd HOSTOBJDIR
../configure  --disable-shared --without-cxx --without-cxx-binding \
	--without-ada --without-curses-h --disable-termcap | tee ../build.log
%make | tee -a ../build.log
cd ..

%target_setup
%target_configure \
	--with-install-prefix=%{buildroot}%{_hhl_cross_target_dir} \
	--with-profile \
	--with-shared \
	--disable-rpath --enable-echo --enable-overwrite \
	--disable-termcap \
	--with-terminfo-dirs="/etc/terminfo:/usr/share/terminfo" \
	| tee -a ../build.log

# Refer to ncurses/Makefile. make_keys needs to be compiled by gcc. Refer to ADA95/gen gen.c need to be compiled by gcc as well#
%make BUILD_CC=gcc  HOST_CC=gcc | tee -a ../build.log


%install
rm -rf %{buildroot}
#cp tack/COPYING LICENSE
echo "Ncurses is coveried by a variety of licenses, please see the " > LICENSE
echo "the source code for more information." >> LICENSE

%target_setup
cd %{_objdir}

%make GZIP='-9' install | tee -a ../build.log

mkdir -p %{buildroot}%{_hhl_cross_target_dir}/%{_hhl_target_lib}
mv %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses.so.5 %{buildroot}%{_hhl_cross_target_dir}/%{_hhl_target_lib}/libncurses.so.5
mv %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses.so.5.4 %{buildroot}%{_hhl_cross_target_dir}/%{_hhl_target_lib}/libncurses.so.5.4
rm %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses.so
rm %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libcurses.so
ln -s ../../%{_hhl_target_lib}/libncurses.so.5 %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses.so
ln -s ../../%{_hhl_target_lib}/libncurses.so.5 %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libcurses.so

cp lib/*_pic.a %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/.

gzip -9 %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_data_dir}/man/man1/tack.1

echo "%defattr(-,root,root)" > ncurses-base.filelist
echo "%defattr(-,root,root)" > ncurses-term.filelist
echo "%dir %{_hhl_cross_target_dir}%{_hhl_target_data_dir}/tabset" >> ncurses-base.filelist
echo "%{_hhl_cross_target_dir}%{_hhl_target_data_dir}/tabset/*" >> ncurses-base.filelist
echo "%dir %{_hhl_cross_target_dir}%{_hhl_target_data_dir}/terminfo" >> ncurses-base.filelist
echo "%dir %{_hhl_cross_target_dir}%{_hhl_target_data_dir}/terminfo/*" >> ncurses-base.filelist

for i in `find %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_data_dir}/terminfo -type f | sed -e s,%{buildroot},,`; do
 case "$i" in \
 */ansi | \
 */dumb | \
 */linux | \
 */rxvt | \
 */screen | */screen-w | \
 */sun | \
 */vt100 | */vt102 | */vt220 | */vt52 | \
 */xterm | */xterm-color | */xterm-r5 | */xterm-r6 | */xterm-vt220 | \
 */xterm-xfree86) echo "%attr(0644,root,root) $i" >> ncurses-base.filelist;; \
 *) echo "%attr(0644,root,root) $i" >> ncurses-term.filelist;; \
 esac
done

# Install Library Optimizer information
%define _optdir %{buildroot}%{_hhl_cross_target_dir}/usr/lib/optinfo
install -d -m 755 %{_optdir}/ncurses%{_hhl_pkg_suffix}
sed -e "s|@CFLAGS@|%{_mvl_target_cflags}|g" %{SOURCE1} > build.ncurses
install -m 755 build.ncurses %{_optdir}/ncurses%{_hhl_pkg_suffix}/build


OBJECTDIR=`/bin/pwd`
NCURSESLIBPATH=/%{_hhl_target_lib}/libncurses.so.%{version}
(cd %{_optdir}/ncurses%{_hhl_pkg_suffix}; umask 022; %{_hhl_target_toolprefix}ar x %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses_pic.a)
(cd %{_optdir}/ncurses%{_hhl_pkg_suffix}; umask 022; %{_hhl_target_toolprefix}libindex %{buildroot}%{_hhl_cross_target_dir}$NCURSESLIBPATH *.o > index)
(umask 022; echo $NCURSESLIBPATH > %{_optdir}/ncurses%{_hhl_pkg_suffix}/path)


%if "%{_hhl_pkg_suffix}" != ""
rm -rf %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_include_dir}
rm -rf %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}
rm -rf %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sharedstate_dir}
%endif 

#Prep for debug info.
chmod u+x %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/{*so*,*.a}
chmod u+x %{buildroot}%{_hhl_cross_target_dir}/%{_hhl_target_lib}/*so*


%clean
rm -rf %{buildroot}


%files -n libncurses%{_hhl_pkg_suffix}
%defattr(-,root,root)
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libform.so.5
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libform.so.5.4
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libmenu.so.5
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libmenu.so.5.4
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libpanel.so.5
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libpanel.so.5.4
%{_hhl_cross_target_dir}/%{_hhl_target_lib}/libncurses.so.5
%{_hhl_cross_target_dir}/%{_hhl_target_lib}/libncurses.so.5.4
%doc ANNOUNCE NEWS README TO-DO build.log 
%doc LICENSE

%files -n libncurses-dev%{_hhl_pkg_suffix} 
%defattr(-,root,root)
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/*.so
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses.a
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libncurses++.a
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libform.a
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libmenu.a
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libpanel.a
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/libcurses.a

%if "%{_hhl_pkg_suffix}" == ""
%{_hhl_cross_target_dir}%{_hhl_target_include_dir}/*.h
%doc %{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man3/*
%endif

%doc LICENSE

%files -n libncurses-dbg%{_hhl_pkg_suffix}
%defattr(-,root,root)
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/*_g.a
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/*_p.a

%doc LICENSE

%files -n libncurses-pic%{_hhl_pkg_suffix}
%defattr(-,root,root)
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/*_pic.a

%doc LICENSE


%files -n libncurses-libopt%{_hhl_pkg_suffix}
%defattr(-,root,root)
%{_hhl_cross_target_dir}/usr/lib/optinfo/ncurses%{_hhl_pkg_suffix}
%doc LICENSE

%if "%{_hhl_pkg_suffix}" == ""

%files -n ncurses-bin
%defattr(-,root,root)
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/captoinfo
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/clear
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/infocmp
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/infotocap
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/reset
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/tack
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/tic
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/toe
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/tput
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/tset
%doc %{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man1/*
%doc %{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man5/*
%doc %{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man7/*
%doc LICENSE


%files -n ncurses-base -f %{_objdir}/ncurses-base.filelist
%defattr(-,root,root)
%doc LICENSE


%files -n ncurses-term -f %{_objdir}/ncurses-term.filelist
%defattr(-,root,root)
%doc LICENSE

%endif

%changelog
* Sat Jan 14 2006 Qunying Pan <qpan@mvista.com>
- Bug 16738: Fix libopt multi-ABI support in ncurses.

* Tue Jul 16 2004 Atsuko Tsubota <atsuko@mvista.com>
- Updated to 5.4 from 5.2

* Wed Feb 27 2002 Joe Green <source@mvista.com>
- Add support for "xtensa" architecture.

* Fri Apr 20 2001 Steve Kinneberg <source@mvista.com>
- Added TCT package description files

* Thu Apr 12 2001 Joe Green <source@mvista.com>
- Added Library Optimizer information package.

* Wed Jan 24 2001 Mark Hatle <source@mvista.com>
- First cut


